Index: trunk/kernel/kern/event.h
===================================================================
--- trunk/kernel/kern/event.h	(revision 1)
+++ trunk/kernel/kern/event.h	(revision 1)
@@ -0,0 +1,257 @@
+/*
+ * kern/event.h - Per-CPU Events-Manager
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _EVENT_H_
+#define _EVENT_H_
+
+#include <types.h>
+#include <list.h>
+
+struct cpu_s;
+
+/** Private event flags */
+#define EVENT_PENDING     1
+
+//////////////////////////////////////////////////
+//              Public Section                  //
+//////////////////////////////////////////////////
+
+/** Local Events Priorities */
+typedef enum
+{
+	E_CLK = 0,			/* Fixed Priority */
+	E_TLB,
+	E_CHR,
+	E_BLK,
+	E_MIGRATE,
+	E_CREATE,
+	E_FORK,
+	E_EXEC,
+	E_FUNC,
+	E_PRIO_NR
+}event_prio_t;
+
+typedef enum
+{
+	EL_LOCAL,
+	EL_REMOTE
+}event_listner_type_t;
+
+/** Opaque event structure */
+struct event_s;
+
+/** Opaque events listner structure */
+struct event_listner_s;
+
+/** Get CPU of given listner */
+#define event_listner_get_cpu(el,name)
+
+/** Event handler type definition */
+#define EVENT_HANDLER(n)  sint_t (n)(struct event_s *event)
+typedef EVENT_HANDLER(event_handler_t);
+
+/** Set event's priority */
+#define event_set_priority(e, _prio)
+
+/** Set event's sender id */
+#define event_set_senderId(e,_id)
+
+/** Set event's handler */
+#define event_set_handler(e,_handler)
+
+/** Set event handler's argument */
+#define event_set_argument(e,_arg)
+
+/** Set handler execution error code */
+#define event_set_error(e,_error)
+
+/** Get event's priority */
+#define event_get_priority(e)
+
+/** Get event's sender id */
+#define event_get_senderId(e)
+
+/** Get event's handler */
+#define event_get_handler(e)
+
+/** Get handler's argument */
+#define event_get_argument(e)
+
+/** Get handler execution error code */
+#define event_get_error(e)
+
+/** True if event manager has a pending event */
+#define event_is_pending(el)
+
+
+/** Initialize event */
+error_t event_init(struct event_s *event);
+
+
+/** Destroy event */
+void event_destroy(struct event_s *event);
+
+
+/** 
+ * Send an event to local event listner 
+ * must be called with interrupts disabled
+ * Doing the same for a remote event listner
+ * is not required
+ */
+void event_send(struct event_s *event, uint_t cpu_gid);
+
+
+/** 
+ * Notify about all recived events,
+ * must be called with interrupts disabled
+ */
+void event_listner_notify(struct event_listner_s *el);
+
+
+/** Initialize event listner */
+error_t event_listner_init(struct event_listner_s *el);
+
+
+/** Destroy event listner */
+void event_listner_destroy(struct event_listner_s *el);
+
+/** Events Manager thread */
+void* thread_event_manager(void *arg);
+
+//////////////////////////////////////////////////
+//             Private Section                  //
+//////////////////////////////////////////////////
+
+
+/** 
+ * Private events list based database 
+ **/
+struct event_list_s
+{
+	volatile uint_t count;
+	struct list_entry root;
+};
+
+/** opaque events listner */
+struct event_listner_s
+{
+	uint_t count;
+	volatile uint_t flags;
+	volatile uint_t prio CACHELINE;
+	struct  event_list_s tbl[E_PRIO_NR];
+		
+};
+
+
+/** internal event info structure */
+typedef struct 
+{
+	/* event type */
+	uint_t prio;
+
+	/* event handler */
+	event_handler_t *handler;
+
+	/* event argument */
+	void *arg;
+
+	/* event sender id */
+	void *id;
+  
+	/* event error code */
+	error_t err;
+}event_info_t;
+
+
+/** Event opaque structure */
+struct event_s
+{
+	/* Event Primary Info */
+	event_info_t e_info;
+
+	/* Event List Chain */
+	struct list_entry e_list;
+
+	/* Event Backup Info */
+	event_info_t e_bckp;
+  
+	/* Event Private Data */
+	void *data;
+};
+
+#define event_backup(e)						\
+	do{							\
+		(e)->e_bckp.prio    = (e)->e_info.prio;		\
+		(e)->e_bckp.handler = (e)->e_info.handler;	\
+		(e)->e_bckp.arg     = (e)->e_info.arg;		\
+		(e)->e_bckp.id      = (e)->e_info.id;		\
+		(e)->e_bckp.err     = (e)->e_info.err;		\
+	}while(0)
+
+#define event_restore(e)					\
+	do{							\
+		(e)->e_info.prio    = (e)->e_bckp.prio;		\
+		(e)->e_info.handler = (e)->e_bckp.handler;	\
+		(e)->e_info.arg     = (e)->e_bckp.arg;		\
+		(e)->e_info.id      = (e)->e_bckp.id;		\
+		(e)->e_info.err     = (e)->e_bckp.err;		\
+	}while(0)
+
+
+#undef event_listner_get_cpu
+#define event_listner_get_cpu(_el,_name)		\
+	list_container((_el), struct cpu_s, _name)
+
+#undef event_set_priority
+#define event_set_priority(e, _prio)  do{(e)->e_info.prio = (_prio);}while(0)
+
+#undef event_set_senderId
+#define event_set_senderId(e,_id)     do{(e)->e_info.id = (_id);}while(0)
+
+#undef event_set_handler
+#define event_set_handler(e,_handler) do{(e)->e_info.handler = (_handler);}while(0)
+
+#undef event_set_argument
+#define event_set_argument(e,_arg)    do{(e)->e_info.arg = (_arg);}while(0)
+
+#undef event_set_error
+#define event_set_error(e,_error)     do{(e)->e_info.err = (_error);}while(0)
+
+#undef event_get_priority
+#define event_get_priority(e)   ((e)->e_info.prio)
+
+#undef event_get_senderId
+#define event_get_senderId(e)   ((e)->e_info.id)
+
+#undef event_get_handler
+#define event_get_handler(e)    ((e)->e_info.handler)
+
+#undef event_get_argument
+#define event_get_argument(e)   ((e)->e_info.arg)
+
+#undef event_get_error
+#define event_get_error(e)      ((e)->e_info.err)
+
+#undef event_is_pending
+#define event_is_pending(el)    ((el)->flags & EVENT_PENDING)
+
+#endif	/* _EVENT_H_ */
Index: trunk/kernel/kern/interrupt.h
===================================================================
--- trunk/kernel/kern/interrupt.h	(revision 1)
+++ trunk/kernel/kern/interrupt.h	(revision 1)
@@ -0,0 +1,55 @@
+/*
+ * kern/interrupt.h - kernel IRQs reservation interface
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ * 
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _INTERRUPT_H_
+#define _INTERRUPT_H_
+
+#include <types.h>
+
+#define IRQ_DYN     0x01	/* Dynamic Allocation */
+#define IRQ_SHD     0x02	/* Shared IRQ */
+
+/* Struct used from device.h */
+struct irq_action_s;
+
+/* Struct used form thread.h */
+struct thread_s;
+
+/* IRQ Manager initialize */
+error_t irq_manager_init();
+
+/* IRQ Ressources Allocation */
+error_t irq_manager_alloc(uint_t irq, uint_t irqs_nr, uint_t flags);
+
+/* IRQ Ressources Liberation */
+error_t irq_manager_free(uint_t irq, uint_t irqs_nr);
+
+/* IRQ Handler Registeration */
+error_t irq_handler_register(struct irq_action_s *info, uint_t irq, uint_t flags);
+
+/* IRQ Handler Unregisteration */
+error_t irq_handler_unregister(uint_t irq);
+
+/* Kernel entry point for interrupt handling */
+void do_interrupt(struct thread_s *this, uint_t irq_num);
+
+#endif	/* _INTERRUPT_H_ */
Index: trunk/kernel/kern/kcond_var.h
===================================================================
--- trunk/kernel/kern/kcond_var.h	(revision 1)
+++ trunk/kernel/kern/kcond_var.h	(revision 1)
@@ -0,0 +1,90 @@
+/*
+ * kern/kcond_var.h - kernel condition variables synchronization
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *  
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _KCOND_VAR_H_
+#define _KCOND_VAR_H_
+
+#include <types.h>
+#include <spinlock.h>
+#include <wait_queue.h>
+
+///////////////////////////////////////////////////
+///               Public Section                ///
+///////////////////////////////////////////////////
+
+/** Kernel Condition Variable Sync Type */
+typedef struct wait_queue_s kcv_t;		
+
+/** Initialize CondVar */
+#define kcv_init(cv,name)
+
+/** Wait on CondVar until condition completion */
+#define kcv_wait(cv,lock)
+
+/** Signal (notifiy) CondVar and Wakeup one waiting thread */
+#define kcv_signal(cv)
+
+/** Destroy CondVar */
+#define kcv_destroy(cv)
+
+/** Broadcast CondVar and return the number of notified threads */
+static inline uint_t kcv_broadcast(kcv_t *cv);
+
+
+///////////////////////////////////////////////////
+///               Private Section               ///
+///////////////////////////////////////////////////
+
+#undef kcv_init
+#define kcv_init(_cv,_name)				\
+	do{						\
+		wait_queue_init((_cv), (_name));	\
+	}while(0)
+
+#undef kcv_wait
+#define kcv_wait(_cv,_lock)				\
+	do{						\
+		wait_on((_cv), WAIT_LAST);		\
+		spinlock_unlock_nosched((_lock));	\
+		sched_sleep(CURRENT_THREAD);		\
+		spinlock_lock((_lock));			\
+	}while(0)
+
+#undef kcv_signal
+#define kcv_signal(_cv)					\
+	do{						\
+		(void)wakeup_one((_cv), WAIT_ANY);	\
+	}while(0)
+
+static inline uint_t kcv_broadcast(kcv_t *cv)
+{
+	return wakeup_all(cv); 
+}
+
+#undef kcv_destroy
+#define kcv_destroy(_cv)						\
+	do{								\
+		if(!(wait_queue_isEmpty((_cv))))			\
+			printk(ERROR,"ERROR: %s: kcv [%s] is busy\n", __FUNCTION__, (_cv)->name); \
+	}while(0)
+
+#endif	/* _KCOND_VAR_H_ */
Index: trunk/kernel/kern/kdmsg.h
===================================================================
--- trunk/kernel/kern/kdmsg.h	(revision 1)
+++ trunk/kernel/kern/kdmsg.h	(revision 1)
@@ -0,0 +1,297 @@
+/*
+ * kdmsg.h - printk like functions and trace messages
+ * 
+ * authors     Ghassan Almaless (2008,2009,2010,2011,2012)
+ *             Mohamed Lamine Karaoui (2015)
+ *             Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *  
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _KDMSG_H_
+#define _KDMSG_H_
+
+#include <hal_types.h>
+#include <spinlock.h>
+#include <stdarg.h>
+
+#define ERROR     DMSG_ERROR
+#define WARNING   DMSG_WARNING
+#define INFO      DMSG_INFO
+#define DEBUG     DMSG_DEBUG
+#define BOOT      DMSG_BOOT
+#define ASSERT    DMSG_ASSERT
+
+#define LEVEL     CONFIG_DMSG_LEVEL
+
+typedef enum
+{
+	PRINTK_KTTY_LOCK,
+	ISR_KTTY_LOCK,
+	NO_KTTY_LOCK
+} 
+ktty_lock_t;
+
+typedef struct kdmsg_channel_s
+{
+	union
+	{
+		global_t val;
+		uint_t id;
+	};
+}
+kdmsg_channel_t;
+
+extern kdmsg_channel_t klog_tty;
+extern kdmsg_channel_t kisr_tty;
+extern kdmsg_channel_t kexcept_tty;
+
+#define printk(level, args...)						\
+	do{								\
+		if((level) <= LEVEL)					\
+			__fprintk(klog_tty.id, PRINTK_KTTY_LOCK, args);	\
+	}while(0)
+
+
+#define isr_dmsg(level, args...)					\
+	do{								\
+		if((level) <= LEVEL)					\
+			__fprintk(kisr_tty.id, ISR_KTTY_LOCK, args);	\
+	}while(0)
+
+#define cpu_log_msg(...)					\
+	do{							\
+		__fprintk(cpu_get_id(), NO_KTTY_LOCK, __VA_ARGS__);	\
+	}while(0)
+
+
+#if (ERROR <= LEVEL)
+#define except_dmsg(args...) do { __fprintk(kexcept_tty.id, NO_KTTY_LOCK, args); } while(0)
+#else
+#define except_dmsg(args...)
+#endif
+
+#if (BOOT <= LEVEL)
+#if CONFIG_SHOW_ALL_BOOT_MSG
+#define boot_dmsg(args...)   do { __arch_boot_dmsg(args); } while(0)
+#else
+#define boot_dmsg(args...)   do { if ( current_cid == 0 ) __arch_boot_dmsg(args); } while(0)
+#endif
+#else
+#define boot_dmsg(args...)
+#endif
+
+void kdmsg_init();
+void kboot_tty_init(boot_info_t *info);
+void bdump(uint8_t *buff, size_t count);
+
+int __perror (int fatal, const char *fmt, ...);
+int __fprintk (int tty, ktty_lock_t ktl, const char *fmt, ...);
+int __arch_boot_dmsg (const char *fmt, ...);
+
+#define PANIC(MSG, ...)						\
+	do{								\
+		__perror(1,"PANIC at line: %d, file: %s , MSG: " MSG"\n", __LINE__,__FILE__, ##__VA_ARGS__);	\
+		while(1);											\
+	} while(0)
+
+
+/* Assert are not executed if the __OPTIMIZE__ macro is defined *
+ * This mean no important code should be put inside an assert	*/
+#if (ASSERT <= LEVEL) && (!defined (__OPTIMIZE__))
+//#if 1
+#define assert(expr) \
+(void) ((expr) ? 0 : __perror(0,"cpu %d: Assert "#expr" faild, line %d, file %s [%d]\n", cpu_get_id(), __LINE__, __FILE__, cpu_time_stamp()))
+#define bassert(expr) \
+(void) ((expr) ? 0 : __arch_boot_dmsg("Assert "#expr" faild, line %d, file %s [%d]\n", __LINE__, __FILE__, cpu_time_stamp()))
+#define assert2(_th,expr) \
+(void) ((expr) ? 0 : __perror(0,"[ %x ] Assert "#expr" faild, line %d, file %s, Thread [%x] on CPU [%d], Current Thread [%x] on CPU [%d], [%u]\n", cpu_time_stamp(), __LINE__,__FILE__, _th, thread_current_cpu((_th))->gid, current_thread, cpu_get_id(), cpu_time_stamp()))
+#else
+#define assert(expr) do{}while(0)
+#define assert2(_th,expr)do{}while(0)
+#define bassert(expr)do{}while(0)
+//#define full_assert(_th,expr)do{}while(0)
+#endif
+
+#define full_assert(_th,expr) \
+(void) ((expr) ? 0 : ({__perror(0,"[ %x ] Assert "#expr" faild, line %d, file %s, Thread [%x] on CPU [%d], Current Thread [%x] on CPU [%d], [%u]\n", cpu_time_stamp(), __LINE__,__FILE__, _th, thread_current_cpu((_th))->gid, current_thread, cpu_get_id(), cpu_time_stamp()); while(1);}))
+
+/////////////////////////////////////////////////////////////////////////
+//      per subsystem printk wrapper upon its debug configuration      //
+/////////////////////////////////////////////////////////////////////////
+
+#define dmsg(level, config, args...)		\
+	do					\
+	{					\
+		if((level) <= (config))		\
+			printk(DEBUG, args);	\
+	} while(0)
+
+#if CONFIG_IOC_DEBUG
+#define ioc_dmsg( args... )   printk( args )
+#else
+#define ioc_dmsg( args... )
+#endif
+
+#if CONFIG_VFAT_DEBUG
+#define vfat_dmsg(level, args...)		\
+	dmsg(level, CONFIG_VFAT_DEBUG, args)
+#else
+#define vfat_dmsg(args...)
+#endif
+
+#if CONFIG_EXT2_DEBUG
+#define ext2_dmsg(level, args...)		\
+	dmsg(level, CONFIG_EXT2_DEBUG, args)
+#else
+#define ext2_dmsg(args...)
+#endif
+
+#if CONFIG_DEVFS_DEBUG
+#define devfs_dmsg(level, args...)		\
+	dmsg(level, CONFIG_DEVFS_DEBUG, args)
+#else
+#define devfs_dmsg(args...)
+#endif
+
+#if CONFIG_SYSFS_DEBUG
+#define sysfs_dmsg(level, args...)		\
+	dmsg(level, CONFIG_SYSFS_DEBUG, args)
+#else
+#define sysfs_dmsg(args...)
+#endif
+
+#if CONFIG_VFS_DEBUG
+#define vfs_dmsg(level, args...)		\
+	dmsg(level, CONFIG_VFS_DEBUG, args)
+#else
+#define vfs_dmsg(args...)
+#endif
+
+#if CONFIG_MAPPER_DEBUG
+#define mapper_dmsg(level, args...)		\
+	dmsg(level, CONFIG_MAPPER_DEBUG, args)
+#else
+#define mapper_dmsg(args...)
+#endif
+
+#if CONFIG_KMEM_DEBUG
+#define kmem_dmsg(args...) boot_dmsg(args)//printk(DEBUG, args)
+#else
+#define kmem_dmsg(args...)
+#endif
+
+#if CONFIG_KHM_DEBUG
+#define khm_dmsg(args...) boot_dmsg(args)//printk(DEBUG, args)
+#else
+#define khm_dmsg(args...)
+#endif
+
+#if CONFIG_KCM_DEBUG
+#define kcm_dmsg(args...) printk(DEBUG, args)
+#else
+#define kcm_dmsg(args...)
+#endif
+
+#if CONFIG_VMM_DEBUG
+#define vmm_dmsg(level, args...)		\
+	dmsg(level, CONFIG_VMM_DEBUG, args)
+#else
+#define vmm_dmsg(args...)
+#endif
+
+#if CONFIG_VMM_REGION_DEBUG
+#define vmm_reg_dmsg(level, args...)			\
+	dmsg(level, CONFIG_VMM_REGION_DEBUG, args)
+#else
+#define vmm_reg_dmsg(args...)
+#endif
+
+#if CONFIG_DQDT_DEBUG
+#define dqdt_dmsg(level, args...)		\
+	dmsg(level, CONFIG_DQDT_DEBUG, args)
+#else
+#define dqdt_dmsg(args...)
+#endif
+
+#if CONFIG_KFIFO_DEBUG
+#define lffb_dmsg(level, args...)		\
+	dmsg(level, CONFIG_KFIFO_DEBUG, args)
+#else
+#define lffb_dmsg(args...)
+#endif
+
+#if CONFIG_FORK_DEBUG
+#define fork_dmsg(level, args...)		\
+	dmsg(level, CONFIG_FORK_DEBUG, args)
+#else
+#define fork_dmsg(args...)
+#endif
+
+#if CONFIG_SHOW_THREAD_MSG
+#define thread_dmsg(level, args...)		\
+	dmsg(level, CONFIG_SHOW_THREAD_MSG, args)
+#else
+#define thread_dmsg(args...)
+#endif
+
+#if CONFIG_ELF_DEBUG
+#define elf_dmsg(level, args...)		\
+	dmsg(level, CONFIG_ELF_DEBUG, args)
+#else
+#define elf_dmsg(args...)
+#endif
+
+
+#if CONFIG_PID_DEBUG
+#define pid_dmsg(level, args...)                \
+        dmsg(level, CONFIG_PID_DEBUG, args)
+#else
+#define pid_dmsg(args...)
+#endif
+
+#if CONFIG_SHOW_SIG_MSG
+#define sig_dmsg(level, args...)                \
+        dmsg(level, CONFIG_SHOW_SIG_MSG, args)
+#else
+#define sig_dmsg(args...)
+#endif
+
+#if CONFIG_HTBL_DEBUG
+#define htbl_dmsg(level, args...)                \
+        dmsg(level, CONFIG_HTBL_DEBUG, args)
+#else
+#define htbl_dmsg(args...)
+#endif
+
+#if CONFIG_SHOW_RPC_MSG
+#define rpc_dmsg(level, args...)                \
+        dmsg(level, CONFIG_SHOW_RPC_MSG, args)
+#else
+#define rpc_dmsg(args...)
+#endif
+
+#if CONFIG_EXEC_DEBUG
+#define exec_dmsg(level, args...)               \
+        dmsg(level, CONFIG_EXEC_DEBUG, args)
+#else
+#define exec_dmsg(args...)
+#endif
+/////////////////////////////////////////////////////////////
+
+#endif // _KDMSG_H_
